# HG changeset patch
# User Stefan Mirea <mireastefangabriel@gmail.com>
# Date 1488971966 -7200
#      Wed Mar 08 13:19:26 2017 +0200
# Node ID d28f4414c0c528f376030c8c3606bf680661d8ea
# Parent  4890b1c4a6bd53f409f994d327054ddd61a5e548
Add nanflag argument to min, max, cummin, cummax (bug #50007)

* max.cc (do_minmax_red_op, do_minmax_red_op<charNDArray>,
do_minmax_red_op<boolNDArray>, do_minmax_bin_op,
do_minmax_bin_op<charNDArray>, do_cumminmax_red_op): New includenan
argument.
(do_minmax_body, do_cumminmax_body): Process "omitnan" and
"includenan" options and pass the flag to do_minmax_red_op,
do_minmax_bin_op or do_cumminmax_red_op.
(do_cumminmax_body): New calls to do_cumminmax_red_op<SparseMatrix>
and do_cumminmax_red_op<SparseComplexMatrix>.
(Fmin, Fmax, Fcummin, Fcummax): Update docstrings with nanflag usage.
New tests for the nanflag argument.
Fix two incorrect tests. Change xtests to tests as complex values with
the same magnitude are now compared by phase angle.

* op-s-m.cc, op-s-s.cc (install_s_m_ops, install_s_s_ops): Install
assignment conversion functions.

* CMatrix.h, CMatrix.cc, fCMatrix.h, fCMatrix.cc (min, max): New
includenan argument. Handle matrix - NaN scalar comparisons correctly.
Remove columns_are_real_only to keep complex ordering.
* dMatrix.h, dMatrix.cc, fMatrix.h, fMatrix.cc (min, max): New
includenan argument.

* CNDArray.cc, CNDArray.h, dNDArray.cc, dNDArray.h, fCNDArray.cc,
fCNDArray.h, fNDArray.cc, fNDArray.h, intNDArray.cc, intNDArray.h
(ComplexNDArray::max, ComplexNDArray::min, ComplexNDArray::cummax,
ComplexNDArray::cummin, NDArray::max, NDArray::min, NDArray::cummax,
NDArray::cummin, FloatComplexNDArray::max, FloatComplexNDArray::min,
FloatComplexNDArray::cummax, FloatComplexNDArray::cummin,
FloatNDArray::max, FloatNDArray::min, FloatNDArray::cummax,
FloatNDArray::cummin, intNDArray<T>::max, intNDArray<T>::min,
intNDArray<T>::cummax, intNDArray<T>::cummin): New includenan
argument.

* CSparse.cc, CSparse.h (SparseComplexMatrix::max,
SparseComplexMatrix::min): New includenan argument. Compare numbers
using operators instead of std::abs to take phase angles into account.
(SparseComplexMatrix::cummax, SparseComplexMatrix::cummin): New
methods and new test for them.
(min, max): New includenan argument. Handle matrix - NaN scalar
comparisons correctly.

* dSparse.cc, dSparse.h (SparseMatrix::max, SparseMatrix::min): New
includenan argument.
(SparseMatrix::cummax, SparseMatrix::cummin): New
methods and new test for them.
(min, max): New includenan argument. Handle matrix - NaN scalar
comparisons correctly.

* lo-mappers.h (min, max): Omit NaN values for complex types. Use
operators instead of abs to take phase angles into account.

* mx-inlines.cc (mx_inline_xmin<double>, mx_inline_xmin<float>,
mx_inline_xmax<double>, mx_inline_xmax<float>): Remove scalar-vector
specializations to preserve NaN scalar value.
(mx_inline_xmin_inan, mx_inline_xmax_inan): New functions.
(mx_inline_min, mx_inline_max, mx_inline_cummin, mx_inline_cummax):
New includenan argument. Proceed to the faster code in OP_MINMAX_FCN2
and OP_CUMMINMAX_FCN2 as soon as r contains no NaNs.
(do_mx_minmax_op, do_mx_cumminmax_op): New includenan argument. Update
callback function type.

* mx-op-decl.h, mx-op-defs.h: New includenan argument.

diff --git a/libinterp/corefcn/max.cc b/libinterp/corefcn/max.cc
--- a/libinterp/corefcn/max.cc
+++ b/libinterp/corefcn/max.cc
@@ -44,7 +44,7 @@ along with Octave; see the file COPYING.
 template <typename ArrayType>
 static octave_value_list
 do_minmax_red_op (const octave_value& arg,
-                  int nargout, int dim, bool ismin)
+                  int nargout, int dim, bool includenan, bool ismin)
 {
   octave_value_list retval (nargout > 1 ? 2 : 1);
   ArrayType array = octave_value_extract<ArrayType> (arg);
@@ -52,17 +52,17 @@ do_minmax_red_op (const octave_value& ar
   if (nargout <= 1)
     {
       if (ismin)
-        retval(0) = array.min (dim);
+        retval(0) = array.min (dim, includenan);
       else
-        retval(0) = array.max (dim);
+        retval(0) = array.max (dim, includenan);
     }
   else
     {
       Array<octave_idx_type> idx;
       if (ismin)
-        retval(0) = array.min (idx, dim);
+        retval(0) = array.min (idx, dim, includenan);
       else
-        retval(0) = array.max (idx, dim);
+        retval(0) = array.max (idx, dim, includenan);
 
       retval(1) = octave_value (idx, true, true);
     }
@@ -80,9 +80,11 @@ do_minmax_red_op (const octave_value& ar
 
 template <>
 octave_value_list
-do_minmax_red_op<charNDArray> (const octave_value& arg,
-                               int nargout, int dim, bool ismin)
+do_minmax_red_op<charNDArray> (const octave_value& arg, int nargout, int dim,
+                               bool includenan, bool ismin)
 {
+  octave_unused_parameter (includenan);
+
   octave_value_list retval (nargout > 1 ? 2 : 1);
   charNDArray array = octave_value_extract<charNDArray> (arg);
 
@@ -110,8 +112,8 @@ do_minmax_red_op<charNDArray> (const oct
 // Specialization for bool arrays (dense or sparse).
 template <>
 octave_value_list
-do_minmax_red_op<boolNDArray> (const octave_value& arg,
-                               int nargout, int dim, bool ismin)
+do_minmax_red_op<boolNDArray> (const octave_value& arg, int nargout, int dim,
+                               bool includenan, bool ismin)
 {
   octave_value_list retval;
 
@@ -132,7 +134,8 @@ do_minmax_red_op<boolNDArray> (const oct
       else
         {
           // any/all don't have indexed versions, so do it via a conversion.
-          retval = do_minmax_red_op<int8NDArray> (arg, nargout, dim, ismin);
+          retval = do_minmax_red_op<int8NDArray> (arg, nargout, dim,
+                                                  includenan, ismin);
 
           retval(0) = retval(0).bool_array_value ();
         }
@@ -141,7 +144,8 @@ do_minmax_red_op<boolNDArray> (const oct
     {
       // Sparse: Don't use any/all trick, as full matrix could exceed memory.
       // Instead, convert to double.
-      retval = do_minmax_red_op<SparseMatrix> (arg, nargout, dim, ismin);
+      retval = do_minmax_red_op<SparseMatrix> (arg, nargout, dim, includenan,
+                                               ismin);
 
       retval(0) = retval(0).sparse_bool_matrix_value ();
     }
@@ -152,7 +156,7 @@ do_minmax_red_op<boolNDArray> (const oct
 template <typename ArrayType>
 static octave_value
 do_minmax_bin_op (const octave_value& argx, const octave_value& argy,
-                  bool ismin)
+                  bool includenan, bool ismin)
 {
   typedef typename ArrayType::element_type ScalarType;
 
@@ -164,9 +168,9 @@ do_minmax_bin_op (const octave_value& ar
       ArrayType y = octave_value_extract<ArrayType> (argy);
 
       if (ismin)
-        retval = min (x, y);
+        retval = min (x, y, includenan);
       else
-        retval = max (x, y);
+        retval = max (x, y, includenan);
     }
   else if (argy.is_scalar_type ())
     {
@@ -174,9 +178,9 @@ do_minmax_bin_op (const octave_value& ar
       ScalarType y = octave_value_extract<ScalarType> (argy);
 
       if (ismin)
-        retval = min (x, y);
+        retval = min (x, y, includenan);
       else
-        retval = max (x, y);
+        retval = max (x, y, includenan);
     }
   else
     {
@@ -184,9 +188,9 @@ do_minmax_bin_op (const octave_value& ar
       ArrayType y = octave_value_extract<ArrayType> (argy);
 
       if (ismin)
-        retval = min (x, y);
+        retval = min (x, y, includenan);
       else
-        retval = max (x, y);
+        retval = max (x, y, includenan);
     }
 
   return retval;
@@ -203,8 +207,11 @@ do_minmax_bin_op (const octave_value& ar
 template <>
 octave_value
 do_minmax_bin_op<charNDArray> (const octave_value& argx,
-                               const octave_value& argy, bool ismin)
+                               const octave_value& argy, bool includenan,
+                               bool ismin)
 {
+  octave_unused_parameter (includenan);
+
   octave_value retval;
 
   charNDArray x = octave_value_extract<charNDArray> (argx);
@@ -238,13 +245,29 @@ do_minmax_body (const octave_value_list&
 {
   int nargin = args.length ();
 
+  bool includenan = false;
+
+  const char *func = ismin ? "min" : "max";
+
+  if (nargin >= 3 && args(nargin - 1).is_string ())
+    {
+      std::string str = args(nargin - 1).string_value ();
+
+      if (str == "includenan")
+        includenan = true;
+      else if (str != "omitnan")
+        error ("%s: unrecognized NaN flag '%s'", func, str.c_str ());
+
+      nargin--;
+      if (nargin == 2 && args(1).is_empty ())
+        nargin--;
+    }
+
   if (nargin < 1 || nargin > 3)
     print_usage ();
 
   octave_value_list retval (nargout > 1 ? 2 : 1);
 
-  const char *func = ismin ? "min" : "max";
-
   if (nargin == 3 || nargin == 1)
     {
       octave_value arg = args(0);
@@ -290,9 +313,10 @@ do_minmax_body (const octave_value_list&
               }
             else if (arg.is_sparse_type ())
               retval = do_minmax_red_op<SparseMatrix> (arg, nargout, dim,
-                                                       ismin);
+                                                       includenan, ismin);
             else
-              retval = do_minmax_red_op<NDArray> (arg, nargout, dim, ismin);
+              retval = do_minmax_red_op<NDArray> (arg, nargout, dim,
+                                                  includenan, ismin);
 
           }
           break;
@@ -301,29 +325,34 @@ do_minmax_body (const octave_value_list&
           {
             if (arg.is_sparse_type ())
               retval = do_minmax_red_op<SparseComplexMatrix> (arg, nargout, dim,
+                                                              includenan,
                                                               ismin);
             else
               retval = do_minmax_red_op<ComplexNDArray> (arg, nargout, dim,
+                                                         includenan,
                                                          ismin);
           }
           break;
 
         case btyp_float:
-          retval = do_minmax_red_op<FloatNDArray> (arg, nargout, dim, ismin);
+          retval = do_minmax_red_op<FloatNDArray> (arg, nargout, dim,
+                                                   includenan, ismin);
           break;
 
         case btyp_float_complex:
           retval = do_minmax_red_op<FloatComplexNDArray> (arg, nargout, dim,
-                                                          ismin);
+                                                          includenan, ismin);
           break;
 
         case btyp_char:
-          retval = do_minmax_red_op<charNDArray> (arg, nargout, dim, ismin);
+          retval = do_minmax_red_op<charNDArray> (arg, nargout, dim,
+                                                  includenan, ismin);
           break;
 
 #define MAKE_INT_BRANCH(X)                                                    \
         case btyp_ ## X:                                                      \
-          retval = do_minmax_red_op<X ## NDArray> (arg, nargout, dim, ismin); \
+          retval = do_minmax_red_op<X ## NDArray> (arg, nargout, dim,         \
+                                                   includenan, ismin);        \
           break;
 
         MAKE_INT_BRANCH (int8);
@@ -338,7 +367,8 @@ do_minmax_body (const octave_value_list&
 #undef MAKE_INT_BRANCH
 
         case btyp_bool:
-          retval = do_minmax_red_op<boolNDArray> (arg, nargout, dim, ismin);
+          retval = do_minmax_red_op<boolNDArray> (arg, nargout, dim,
+                                                  includenan, ismin);
           break;
 
         default:
@@ -367,9 +397,11 @@ do_minmax_body (const octave_value_list&
             if ((argx.is_sparse_type ()
                  && (argy.is_sparse_type () || argy.is_scalar_type ()))
                 || (argy.is_sparse_type () && argx.is_scalar_type ()))
-              retval = do_minmax_bin_op<SparseMatrix> (argx, argy, ismin);
+              retval = do_minmax_bin_op<SparseMatrix> (argx, argy, includenan,
+                                                       ismin);
             else
-              retval = do_minmax_bin_op<NDArray> (argx, argy, ismin);
+              retval = do_minmax_bin_op<NDArray> (argx, argy, includenan,
+                                                  ismin);
           }
           break;
 
@@ -379,27 +411,33 @@ do_minmax_body (const octave_value_list&
                  && (argy.is_sparse_type () || argy.is_scalar_type ()))
                 || (argy.is_sparse_type () && argx.is_scalar_type ()))
               retval = do_minmax_bin_op<SparseComplexMatrix> (argx, argy,
+                                                              includenan,
                                                               ismin);
             else
-              retval = do_minmax_bin_op<ComplexNDArray> (argx, argy, ismin);
+              retval = do_minmax_bin_op<ComplexNDArray> (argx, argy,
+                                                         includenan, ismin);
           }
           break;
 
         case btyp_float:
-          retval = do_minmax_bin_op<FloatNDArray> (argx, argy, ismin);
+          retval = do_minmax_bin_op<FloatNDArray> (argx, argy, includenan,
+                                                   ismin);
           break;
 
         case btyp_float_complex:
-          retval = do_minmax_bin_op<FloatComplexNDArray> (argx, argy, ismin);
+          retval = do_minmax_bin_op<FloatComplexNDArray> (argx, argy,
+                                                          includenan, ismin);
           break;
 
         case btyp_char:
-          retval = do_minmax_bin_op<charNDArray> (argx, argy, ismin);
+          retval = do_minmax_bin_op<charNDArray> (argx, argy, includenan,
+                                                  ismin);
           break;
 
-#define MAKE_INT_BRANCH(X)                                             \
-        case btyp_ ## X:                                               \
-          retval = do_minmax_bin_op<X ## NDArray> (argx, argy, ismin); \
+#define MAKE_INT_BRANCH(X)                                                 \
+        case btyp_ ## X:                                                   \
+          retval = do_minmax_bin_op<X ## NDArray> (argx, argy, includenan, \
+                                                   ismin);                 \
           break;
 
         MAKE_INT_BRANCH (int8);
@@ -415,7 +453,8 @@ do_minmax_body (const octave_value_list&
 
         // FIXME: This is what should happen when boolNDArray has max()
         // case btyp_bool:
-        //   retval = do_minmax_bin_op<boolNDArray> (argx, argy, ismin);
+        //   retval = do_minmax_bin_op<boolNDArray> (argx, argy, includenan,
+        //                                           ismin);
         //   break;
 
         default:
@@ -438,6 +477,8 @@ DEFUN (min, args, nargout,
 @deftypefnx {} {} min (@var{x}, [], @var{dim})
 @deftypefnx {} {[@var{w}, @var{iw}] =} min (@var{x})
 @deftypefnx {} {} min (@var{x}, @var{y})
+@deftypefnx {} {} min (@dots{}, "omitnan")
+@deftypefnx {} {} min (@dots{}, "includenan")
 Find minimum values in the array @var{x}.
 
 For a vector argument, return the minimum value.  For a matrix argument,
@@ -451,6 +492,9 @@ set to the empty matrix.
 
 For two matrices (or a matrix and a scalar), return the pairwise minimum.
 
+The optional @qcode{"nanflag"} argument specifies if NaN values found in the
+input array(s) are to be ignored or propagated to the result.
+
 Thus,
 
 @example
@@ -538,9 +582,7 @@ the first index of the minimum value(s).
 ## Sparse double values
 %!assert (min (sparse ([1, 4, 2, 3])), sparse (1))
 %!assert (min (sparse ([1; -10; 5; -2])), sparse(-10))
-## FIXME: sparse doesn't order complex values by phase angle
-%!xtest
-%! assert (min (sparse ([4, 2i 4.999; -2, 2, 3+4i])), sparse ([-2, 2, 4.999]));
+%!assert (min (sparse ([4, 2i 4.999; -2, 2, 3+4i])), sparse ([-2, 2, 4.999]));
 
 ## Test dimension argument
 %!test
@@ -553,6 +595,26 @@ the first index of the minimum value(s).
 %! assert (ndims (i), 2);
 %! assert (i, [1, 1; 1, 1]);
 
+## Test nanflag argument
+%!assert (min ([3, NaN, 1, 2], [], "omitnan"), 1)
+%!test
+%! [y, i] = min (single ([3, NA, 1, NaN, 2]), [], "includenan");
+%! assert (y, single (NA));
+%! assert (i, 2);
+%!test
+%! x = sparse ([NA, 0, NaN; NaN, -2, 0]);
+%! assert (min (x, [], "includenan"), sparse ([NA, -2, NaN]));
+%!test
+%! x = [1, NA+4i; NaN+6i, 3];
+%! y = [2; NaN+5i];
+%! assert (min (x, y, "omitnan"), [1, 2; NaN+6i, 3]);
+%! assert (min (x, y, "includenan"), [1, NA+4i; NaN+6i, NaN+5i]);
+%!test
+%! x = reshape ([1, 2, 3, NaN, NaN, NA, 4, NaN], [2,2,2]);
+%! [y, i] = min (x, [], 2, "includenan");
+%! assert (y, reshape ([1, NaN, NaN, NA], [2,1,2]));
+%! assert (i, reshape ([1, 2, 1, 1], [2,1,2]));
+
 ## Test 2-output forms for various arg types
 ## Special routines for char arrays
 %!test
@@ -584,12 +646,9 @@ the first index of the minimum value(s).
 %! assert (min (x, 3), [1 2 3 3]);
 %! assert (min (2, x), [1 2 2 2]);
 %! assert (min (x, 2.1i), [1 2 2.1i 2.1i]);
-## FIXME: Ordering of complex results with equal magnitude is not by phase
-##        angle in the 2-input form.  Instead, it is in the order in which it
-##        appears in the argument list.
-%!xtest
+%!test
 %! x = [1, 2, 3, 4];  y = fliplr (x);
-%! assert (min (x, 2i), [2i 2i 3 4]);
+%! assert (min (x, 2i), [1 2 2i 2i]);
 ## Special routines for char arrays
 %!assert (min ("abc", "b"), [97 98 98])
 %!assert (min ("b", "cba"), [98 98 97])
@@ -648,6 +707,7 @@ the first index of the minimum value(s).
 %!error min ()
 %!error min (1, 2, 3, 4)
 %!error <DIM must be a valid dimension> min ([1 2; 3 4], [], -3)
+%!error <unrecognized NaN flag 'foobar'> min (1, [], "foobar")
 %!warning <second argument is ignored> min ([1 2 3 4], 2, 2);
 %!error <wrong type argument 'cell'> min ({1 2 3 4})
 %!error <cannot compute min \(cell, scalar\)> min ({1, 2, 3}, 2)
@@ -659,6 +719,8 @@ DEFUN (max, args, nargout,
 @deftypefnx {} {} max (@var{x}, [], @var{dim})
 @deftypefnx {} {[@var{w}, @var{iw}] =} max (@var{x})
 @deftypefnx {} {} max (@var{x}, @var{y})
+@deftypefnx {} {} max (@dots{}, "omitnan")
+@deftypefnx {} {} max (@dots{}, "includenan")
 Find maximum values in the array @var{x}.
 
 For a vector argument, return the maximum value.  For a matrix argument,
@@ -672,6 +734,9 @@ set to the empty matrix.
 
 For two matrices (or a matrix and a scalar), return the pairwise maximum.
 
+The optional @qcode{"nanflag"} argument specifies if NaN values found in the
+input array(s) are to be ignored or propagated to the result.
+
 Thus,
 
 @example
@@ -764,13 +829,33 @@ the first index of the maximum value(s).
 ## Test dimension argument
 %!test
 %! x = reshape (1:8, [2,2,2]);
-%! assert (min (x, [], 1), reshape ([1, 3, 5, 7], [1,2,2]));
-%! assert (min (x, [], 2), reshape ([1, 2, 5, 6], [2,1,2]));
-%! [y, i] = min (x, [], 3);
+%! assert (max (x, [], 1), reshape ([2, 4, 6, 8], [1,2,2]));
+%! assert (max (x, [], 2), reshape ([3, 4, 7, 8], [2,1,2]));
+%! [y, i] = max (x, [], 3);
 %! assert (ndims (y), 2);
-%! assert (y, [1, 3; 2, 4]);
+%! assert (y, [5, 7; 6, 8]);
 %! assert (ndims (i), 2);
-%! assert (i, [1, 1; 1, 1]);
+%! assert (i, [2, 2; 2, 2]);
+
+## Test nanflag argument
+%!assert (max ([3, NaN, 1, 2], [], "omitnan"), 3)
+%!test
+%! [y, i] = max (single ([3, NA, 1, NaN, 2]), [], "includenan");
+%! assert (y, single (NA));
+%! assert (i, 2);
+%!test
+%! x = sparse ([NA, -2, 0; NaN, 0, NaN]);
+%! assert (max (x, [], "includenan"), sparse ([NA, 0, NaN]));
+%!test
+%! x = [1, NA+4i; NaN+6i, 3];
+%! y = [2; NaN+5i];
+%! assert (max (x, y, "omitnan"), [2, 2; NaN+6i, 3]);
+%! assert (max (x, y, "includenan"), [2, NA+4i; NaN+6i, NaN+5i]);
+%!test
+%! x = reshape ([1, 2, 3, NaN, NaN, NA, 4, NaN], [2,2,2]);
+%! [y, i] = max (x, [], 2, "includenan");
+%! assert (y, reshape ([3, NaN, NaN, NA], [2,1,2]));
+%! assert (i, reshape ([2, 2, 1, 1], [2,1,2]));
 
 ## Test 2-output forms for various arg types
 ## Special routines for char arrays
@@ -803,10 +888,7 @@ the first index of the maximum value(s).
 %! assert (max (x, 3), [3 3 3 4]);
 %! assert (max (2, x), [2 2 3 4]);
 %! assert (max (x, 2.1i), [2.1i 2.1i 3 4]);
-## FIXME: Ordering of complex results with equal magnitude is not by phase
-##        angle in the 2-input form.  Instead, it is in the order in which it
-##        appears in the argument list.
-%!xtest
+%!test
 %! x = [1, 2, 3, 4];  y = fliplr (x);
 %! assert (max (x, 2i), [2i 2i 3 4]);
 ## Special routines for char arrays
@@ -872,6 +954,7 @@ the first index of the maximum value(s).
 %!error max ()
 %!error max (1, 2, 3, 4)
 %!error <DIM must be a valid dimension> max ([1 2; 3 4], [], -3)
+%!error <unrecognized NaN flag 'foobar'> max (1, [], "foobar")
 %!warning <second argument is ignored> max ([1 2 3 4], 2, 2);
 %!error <wrong type argument 'cell'> max ({1 2 3 4})
 %!error <cannot compute max \(cell, scalar\)> max ({1, 2, 3}, 2)
@@ -881,7 +964,7 @@ the first index of the maximum value(s).
 template <typename ArrayType>
 static octave_value_list
 do_cumminmax_red_op (const octave_value& arg,
-                     int nargout, int dim, bool ismin)
+                     int nargout, int dim, bool includenan, bool ismin)
 {
   octave_value_list retval (nargout > 1 ? 2 : 1);
   ArrayType array = octave_value_extract<ArrayType> (arg);
@@ -889,18 +972,18 @@ do_cumminmax_red_op (const octave_value&
   if (nargout <= 1)
     {
       if (ismin)
-        retval(0) = array.cummin (dim);
+        retval(0) = array.cummin (dim, includenan);
       else
-        retval(0) = array.cummax (dim);
+        retval(0) = array.cummax (dim, includenan);
     }
   else
     {
       retval.resize (2);
       Array<octave_idx_type> idx;
       if (ismin)
-        retval(0) = array.cummin (idx, dim);
+        retval(0) = array.cummin (idx, dim, includenan);
       else
-        retval(0) = array.cummax (idx, dim);
+        retval(0) = array.cummax (idx, dim, includenan);
 
       retval(1) = octave_value (idx, true, true);
     }
@@ -914,11 +997,25 @@ do_cumminmax_body (const octave_value_li
 {
   int nargin = args.length ();
 
+  bool includenan = false;
+
+  const char *func = ismin ? "cummin" : "cummax";
+
+  if (nargin >= 2 && args(nargin - 1).is_string ())
+    {
+      std::string str = args(nargin - 1).string_value ();
+
+      if (str == "includenan")
+        includenan = true;
+      else if (str != "omitnan")
+        error ("%s: unrecognized NaN flag '%s'", func, str.c_str ());
+
+      nargin--;
+    }
+
   if (nargin < 1 || nargin > 2)
     print_usage ();
 
-  const char *func = ismin ? "cummin" : "cummax";
-
   octave_value arg = args(0);
   int dim = -1;
   if (nargin == 2)
@@ -934,26 +1031,37 @@ do_cumminmax_body (const octave_value_li
   switch (arg.builtin_type ())
     {
     case btyp_double:
-      retval = do_cumminmax_red_op<NDArray> (arg, nargout, dim, ismin);
+      if (arg.is_sparse_type ())
+        retval = do_cumminmax_red_op<SparseMatrix> (arg, nargout, dim,
+                                                    includenan, ismin);
+      else
+        retval = do_cumminmax_red_op<NDArray> (arg, nargout, dim, includenan,
+                                               ismin);
       break;
 
     case btyp_complex:
-      retval = do_cumminmax_red_op<ComplexNDArray> (arg, nargout, dim,
-                                                    ismin);
+      if (arg.is_sparse_type ())
+        retval = do_cumminmax_red_op<SparseComplexMatrix> (arg, nargout, dim,
+                                                           includenan, ismin);
+      else
+        retval = do_cumminmax_red_op<ComplexNDArray> (arg, nargout, dim,
+                                                      includenan, ismin);
       break;
 
     case btyp_float:
-      retval = do_cumminmax_red_op<FloatNDArray> (arg, nargout, dim, ismin);
+      retval = do_cumminmax_red_op<FloatNDArray> (arg, nargout, dim,
+                                                  includenan, ismin);
       break;
 
     case btyp_float_complex:
       retval = do_cumminmax_red_op<FloatComplexNDArray> (arg, nargout, dim,
-                                                         ismin);
+                                                         includenan, ismin);
       break;
 
 #define MAKE_INT_BRANCH(X)                                                   \
     case btyp_ ## X:                                                         \
-      retval = do_cumminmax_red_op<X ## NDArray> (arg, nargout, dim, ismin); \
+      retval = do_cumminmax_red_op<X ## NDArray> (arg, nargout, dim,         \
+                                                  includenan, ismin);        \
       break;
 
       MAKE_INT_BRANCH (int8);
@@ -970,7 +1078,7 @@ do_cumminmax_body (const octave_value_li
     case btyp_bool:
       {
         retval = do_cumminmax_red_op<int8NDArray> (arg, nargout, dim,
-                                                   ismin);
+                                                   includenan, ismin);
         if (retval.length () > 0)
           retval(0) = retval(0).bool_array_value ();
       }
@@ -988,6 +1096,8 @@ DEFUN (cummin, args, nargout,
 @deftypefn  {} {} cummin (@var{x})
 @deftypefnx {} {} cummin (@var{x}, @var{dim})
 @deftypefnx {} {[@var{w}, @var{iw}] =} cummin (@var{x})
+@deftypefnx {} {} cummin (@dots{}, "omitnan")
+@deftypefnx {} {} cummin (@dots{}, "includenan")
 Return the cumulative minimum values along dimension @var{dim}.
 
 If @var{dim} is unspecified it defaults to column-wise operation.  For
@@ -1012,6 +1122,9 @@ iw = 1  2  2  4  4  6
 @end group
 @end example
 
+The optional @qcode{"nanflag"} argument specifies if NaN values found in the
+input array are to be ignored or propagated in the result.
+
 @seealso{cummax, min, max}
 @end deftypefn */)
 {
@@ -1034,6 +1147,21 @@ iw = 1  2  2  4  4  6
 %! assert (ndims (iw), 3);
 %! assert (iw, ones (2,2,2));
 
+## Test nanflag argument
+%!assert (cummin ([NA, 3, 1, 2], "omitnan"), [NA, 3, 1, 1])
+%!test
+%! [w, iw] = cummin (single ([3, 1, NA, 2, NaN]), "includenan");
+%! assert (w, single ([3, 1, NA, NA, NA]));
+%! assert (iw, [1, 2, 3, 3, 3]);
+%!test
+%! x = sparse ([NaN+i, 2, 0; NaN+2i, 0, NA]);
+%! assert (cummin (x, "includenan"), sparse ([NaN+i, 2, 0; NaN+i, 0, NA]));
+%!test
+%! x = reshape ([1, 2, 3, NaN, NaN, NA, 4, NaN], [2,2,2]);
+%! [w, iw] = cummin (x, 2, "includenan");
+%! assert (w, reshape ([1, 2, 1, NaN, NaN, NA, NaN, NA], [2,2,2]));
+%! assert (iw, reshape ([1, 1, 1, 2, 1, 1, 1, 1], [2,2,2]));
+
 %!error cummin ()
 %!error cummin (1, 2, 3)
 */
@@ -1043,6 +1171,8 @@ DEFUN (cummax, args, nargout,
 @deftypefn  {} {} cummax (@var{x})
 @deftypefnx {} {} cummax (@var{x}, @var{dim})
 @deftypefnx {} {[@var{w}, @var{iw}] =} cummax (@dots{})
+@deftypefnx {} {} cummax (@dots{}, "omitnan")
+@deftypefnx {} {} cummax (@dots{}, "includenan")
 Return the cumulative maximum values along dimension @var{dim}.
 
 If @var{dim} is unspecified it defaults to column-wise operation.  For
@@ -1067,6 +1197,9 @@ iw = 1  2  2  4  4  4
 @end group
 @end example
 
+The optional @qcode{"nanflag"} argument specifies if NaN values found in the
+input array are to be ignored or propagated in the result.
+
 @seealso{cummin, max, min}
 @end deftypefn */)
 {
@@ -1089,6 +1222,21 @@ iw = 1  2  2  4  4  4
 %! assert (ndims (iw), 3);
 %! assert (iw, ones (2,2,2));
 
+## Test nanflag argument
+%!assert (cummax ([NA, 3, 1, 2], "omitnan"), [NA, 3, 3, 3])
+%!test
+%! [w, iw] = cummax (single ([3, 1, NA, 2, NaN]), "includenan");
+%! assert (w, single ([3, 3, NA, NA, NA]));
+%! assert (iw, [1, 1, 3, 3, 3]);
+%!test
+%! x = sparse ([NaN+i, 2, 0; NaN+2i, 0, NA]);
+%! assert (cummax (x, "includenan"), sparse ([NaN+i, 2, 0; NaN+i, 2, NA]));
+%!test
+%! x = reshape ([1, 2, 3, NaN, NaN, NA, 4, NaN], [2,2,2]);
+%! [w, iw] = cummax (x, 2, "includenan");
+%! assert (w, reshape ([1, 2, 3, NaN, NaN, NA, NaN, NA], [2,2,2]));
+%! assert (iw, reshape ([1, 1, 2, 2, 1, 1, 1, 1], [2,2,2]));
+
 %!error cummax ()
 %!error cummax (1, 2, 3)
 */
diff --git a/libinterp/operators/op-s-m.cc b/libinterp/operators/op-s-m.cc
--- a/libinterp/operators/op-s-m.cc
+++ b/libinterp/operators/op-s-m.cc
@@ -29,6 +29,7 @@ along with Octave; see the file COPYING.
 #include "ov.h"
 #include "ov-scalar.h"
 #include "ov-float.h"
+#include "ov-flt-complex.h"
 #include "ov-re-mat.h"
 #include "ov-flt-re-mat.h"
 #include "ov-typeinfo.h"
@@ -134,6 +135,8 @@ install_s_m_ops (void)
 
   INSTALL_ASSIGNCONV (octave_scalar, octave_matrix, octave_matrix);
   INSTALL_ASSIGNCONV (octave_float_scalar, octave_matrix, octave_float_matrix);
+  INSTALL_ASSIGNCONV (octave_float_complex_scalar, octave_matrix,
+                      octave_float_complex_matrix);
 
   INSTALL_WIDENOP (octave_scalar, octave_matrix, matrix_conv);
 }
diff --git a/libinterp/operators/op-s-s.cc b/libinterp/operators/op-s-s.cc
--- a/libinterp/operators/op-s-s.cc
+++ b/libinterp/operators/op-s-s.cc
@@ -29,8 +29,10 @@ along with Octave; see the file COPYING.
 #include "errwarn.h"
 #include "ovl.h"
 #include "ov.h"
+#include "ov-complex.h"
 #include "ov-scalar.h"
 #include "ov-float.h"
+#include "ov-flt-complex.h"
 #include "ov-re-mat.h"
 #include "ov-flt-re-mat.h"
 #include "ov-typeinfo.h"
@@ -174,4 +176,9 @@ install_s_s_ops (void)
   INSTALL_ASSIGNCONV (octave_scalar, octave_null_matrix, octave_matrix);
   INSTALL_ASSIGNCONV (octave_scalar, octave_null_str, octave_matrix);
   INSTALL_ASSIGNCONV (octave_scalar, octave_null_sq_str, octave_matrix);
+
+  INSTALL_ASSIGNCONV (octave_float_complex_scalar, octave_scalar,
+                      octave_float_complex_matrix);
+  INSTALL_ASSIGNCONV (octave_float_complex_scalar, octave_complex_scalar,
+                      octave_float_complex_matrix);
 }
